var StringBuilder = require("bn-lang-util").StringBuilder;

var DefaultAppender = function(){this.init.apply(this, arguments);};
exports.DefaultAppender = DefaultAppender;

DefaultAppender.prototype.init = function(_name, _output) {

	this.name = _name;
	this.output = _output;
	this.layout = new DefaultLayout();
	this.threshold = Level.ALL;
};

DefaultAppender.prototype.doAppend = function(_logEvent) {

	if(_logEvent.getLevel().isGreaterOrEqual(this.getThreshold())) {

		this.append(_logEvent);
	}
};

DefaultAppender.prototype.append = function(_logEvent) {

	var layout = this.getLayout();

	this.output(new StringBuilder()
				.append(layout.getHeader())
				.append(layout.format(_logEvent))
				.append(layout.getFooter())
				.append("\n")
				.toString());
};

DefaultAppender.prototype.getName = function() {

	return this.name;
};

DefaultAppender.prototype.getLayout = function() {

	return this.layout;
};

DefaultAppender.prototype.setLayout = function(_layout) {

	this.layout = _layout;
};

DefaultAppender.prototype.getThreshold = function() {

	return this.threshold;
};

DefaultAppender.prototype.setThreshold = function(_threshold) {

	this.threshold = _threshold;
};
