var Hash = require("bn-lang").Hash;

var LogConfiguration = function(){this.init.apply(this, arguments);};
exports.LogConfiguration = LogConfiguration;

LogConfiguration.prototype.init = function(_configuration) {

	var configuration = _configuration;
	this.getConfiguration = function() {

		return configuration;
	};
};

LogConfiguration.prototype.configure = function() {

	var _appenersMap = new Hash();

	var i=0;

	var _appenders = this.getConfiguration().appenders;
	for(i=0;i<_appenders.length;i++) {

		_appender = _appenders[i];

		var realAppender = new _appender.type(_appender.name);

		if(_appender.threshold) {

			realAppender.setThreshold(Level.toLevel(_appender.threshold));
		}

		if(_appender.layout) {

			var realLayout = new _appender.layout();

			if(_appender.layout_conversion) {

				realLayout.setConversionPattern(_appender.layout_conversion);
			}

			realAppender.setLayout(realLayout);
		}
		_appenersMap.put(realAppender.getName(), realAppender);
	}

	var _loggers = this.getConfiguration().loggers;
	for(i=0;i<_loggers.length;i++) {

		var logger = _loggers[i];

		var realLogger = LogManager.getLogger(logger.name);
		if(logger.effectiveLevel) {
		
			realLogger.setEffectiveLevel(Level.toLevel(logger.effectiveLevel));
		}

		if(logger.appenders) {

			for(var j=0;j<logger.appenders.length;j++) {
			
				realLogger.addAppender(_appenersMap.get(logger.appenders[j]));
			}
		}
	}
};
