var Logger = function(){this.init.apply(this, arguments);};
exports.Logger = Logger;

Logger.prototype.init = function(_name) {

	this.name = _name;
	this.appenders = [];
	this.effectiveLevel = Level.FATAL;
};

Logger.prototype.log = function(_level, _message, _exception) {

	if(_level.isGreaterOrEqual(this.effectiveLevel)) {

		var _logEvent = new LogEvent(this, _level, _message, _exception);
		this.appenders.each(function(_appender) {

			_appender.doAppend(_logEvent);
		});
	}
};

Logger.prototype.getName = function() {

	return this.name;
};

Logger.prototype.addAppender = function(_appender) {

	this.appenders.add(_appender);
};

Logger.prototype.removeAppender = function(_appender) {

	this.appenders.remove(_appender);
};

Logger.prototype.removeAllAppenders = function() {

	this.appenders.clear();
};

Logger.prototype.getEffectiveLevel = function() {

	return this.effectiveLevel;
};

Logger.prototype.setEffectiveLevel = function(_level) {

	this.effectiveLevel = _level;
	return this;
};

Logger.prototype.trace = function(_message, _exception) {

	this.log(Level.TRACE, _message, _exception);
};

Logger.prototype.debug = function(_message, _exception) {

	this.log(Level.DEBUG, _message, _exception);
};

Logger.prototype.info = function(_message, _exception) {

	this.log(Level.INFO, _message, _exception);
};

Logger.prototype.warn = function(_message, _exception) {

	this.log(Level.WARN, _message, _exception);
};

Logger.prototype.error = function(_message, _exception) {

	this.log(Level.ERROR, _message, _exception);
};

Logger.prototype.fatal = function(_message, _exception) {

	this.log(Level.FATAL, _message, _exception);
};

Logger.prototype.isTraceEnabled = function() {

	return Level.TRACE.isGreaterOrEqual(this.getLevel());
};

Logger.prototype.isDebugEnabled = function() {

	return Level.DEBUG.isGreaterOrEqual(this.getLevel());
};

Logger.prototype.isInfoEnabled = function() {

	return Level.INFO.isGreaterOrEqual(this.getLevel());
};

Logger.prototype.isWarnEnabled = function() {

	return Level.WARN.isGreaterOrEqual(this.getLevel());
};

Logger.prototype.isErrorEnabled = function() {

	return Level.ERROR.isGreaterOrEqual(this.getLevel());
};

Logger.prototype.isFatalEnabled = function() {

	return Level.FATAL.isGreaterOrEqual(this.getLevel());
};
