global.$GLOBAL_OBJECT = global;
require.paths.push("../");
require("bn-lang");

var LogManager = require("bn-log").LogManager;
var PatternLayout = require("bn-log").PatternLayout;
var DefaultAppender = require("bn-log").DefaultAppender;
var Level = require("bn-log").Level;

var logger = LogManager.getObjectLogger("object logger");
logger.setEffectiveLevel(Level.TRACE);

var layout = new PatternLayout();
layout.setConversionPattern("%r %d{DATE} [%-5p] %c - %m%n");

var appender = new DefaultAppender("test.one", require("sys").print);
appender.setLayout(layout);
logger.addAppender(appender);

var Parent = function(){this.init.apply(this, arguments);};
Parent.prototype.init = function(_name) {

	this.name = _name;

	this.test = function() {

		return "test in parent";
	}
};

Parent.prototype.sayName = function(_extra) {

	return "Parent: " + this.name + " " + _extra;
};

Parent.prototype.sayBoo = function() {

	return "booooo " + this.name;
};

var Child = function(){this.init.apply(this, arguments);};
Child.prototype = new Parent();
Child.prototype.constructor = Child;
Child.parentclass = Parent.prototype;
Child.prototype.init = function(_name) {

	Child.parentclass.init.apply(this, [_name]);

	this.anotherTest = function() {

		return "another " + this.test();
	};

	this.test = function() {

		return "test in child";
	};
};

Child.prototype.sayName = function() {

	return "Child: " + this.name;
};

var _parent = new Parent("Matt");
var _child = new Child("Sam");

logger.addObject("The Parent", _parent, {funcs: [{name:"sayName", after:true}]});
logger.addObject("The Child", _child, {after: true});

_parent.sayBoo();
_parent.sayName(" I'm Great ");
_child.sayName();
