var EqualsBuilder = function(){this.init.apply(this, arguments);};
exports.EqualsBuilder = EqualsBuilder;

/**
* @class EqualsBuilder
* @description  Utility to test equality among various objects. Mostly used in individual <Class>#equals method to one object against another.
* @constructor
*/

/** @ignore */
EqualsBuilder.prototype.init = function() {

	this.isEquals = true;
};

/**
* Test two objects for equality.
* @param {Object} _object1
* @param {Object} _object2
* @return {EqualsBuilder}
*/
EqualsBuilder.prototype.append = function(_object1, _object2) {

	if(!this.isEquals){ return this; }
	if(_object1 === _object2){ return this; }
	if(_object1 == null || _object2 == null) {

		this.isEquals = false;
	}

	if(this.isEquals) {

		this.isEquals = _object1.equals(_object2);
	}

	return this;
};

/**
* Returns the derived equals boolean.
* @return {Boolean}
*/
EqualsBuilder.prototype.getEquals = function() {

	return this.isEquals;
};
