var StringBuilder = function(){this.init.apply(this, arguments);};
exports.StringBuilder = StringBuilder;

/**
* @class StringBuilder
* @description A cleaner way to concatenate strings.
* @constructor
* @param {String} _initString init the buffer.
*/

/** @ignore */
StringBuilder.prototype.init = function(_initString) {

	this.str = null;
	this.current = 0;
	this.parts = [];
	this.length = 0;

	if(_initString != null) {

		this.append(_initString);
	}
};

/**
* Appends the _appendString String to the current buffer.
* @param {String} _appendString
* @return StringBuilder
*/
StringBuilder.prototype.append = function(_appendString) {

	// append the string
	this.parts[this.current++] = _appendString.toString();

	// reset the add new lengh for appended string
	this.length += _appendString.toString().length;

	// reset cache
	this.str = null;

	// return the Instance for method chaining
	return this;
};

/**
* Returns whether this object is equal to the specified _object.
* @param {Object} _object
* @return {Boolean}
*/
StringBuilder.prototype.equals = function(_object) {

	if(this === _object) {
		return true;
	}
	if(!this.getClass().isInstance(_object)) {

		return false;
	}

	return this.toString() == _object.toString();
};

/**
* Returns a String representation of a StringBuilder.
* @return {String}
*/
StringBuilder.prototype.toString = function() {

	if(this.str) {

		return this.str;
	}

	var newStr = this.parts.join("");
	this.parts = [newStr];
	this.current = 1;
	this.length = newStr.length;
	this.str = newStr;

	return this.str;
};
