var TestCase = require("bn-unit").TestCase;
var MyObject = require("./MyObject").MyObject;

// setup test case
var EqualsBuilderTest = function(){this.init.apply(this, arguments);};
exports.EqualsBuilderTest = EqualsBuilderTest;

EqualsBuilderTest.prototype = new TestCase();
EqualsBuilderTest.prototype.constructor = EqualsBuilderTest;
EqualsBuilderTest.parentclass = TestCase.prototype;
EqualsBuilderTest.prototype.init = function() {};
EqualsBuilderTest.prototype.setUp = function() {

	EqualsBuilderTest.parentclass.setUp.apply(this, []);
};
EqualsBuilderTest.prototype.tearDown = function() {

	EqualsBuilderTest.parentclass.tearDown.apply(this, []);
};
EqualsBuilderTest.getName = function() {

	return "EqualsBuilder";
};

// add tests
EqualsBuilderTest.prototype.testEqualsBuilderProps = function() {

	var _object1 = new MyObject(1);
	var _object2 = new MyObject(1);

	this.assertTrue(_object1.equals(_object2));
};

EqualsBuilderTest.prototype.testEqualsBuilderIdentity = function() {

	var _object1 = new MyObject(1);

	this.assertTrue(_object1.equals(_object1));
};

EqualsBuilderTest.prototype.testNotEqualsBuilder = function() {

	var _object1 = new MyObject(1);
	var _object2 = new MyObject(2);

	this.assertFalse(_object1.equals(_object2));
};
