var TestCase = require("bn-unit").TestCase;
var SimpleDateFormat = require("bn-lang-util").SimpleDateFormat;

// setup test case
var SimpleDateFormatTest = function(){this.init.apply(this, arguments);};
exports.SimpleDateFormatTest = SimpleDateFormatTest;

SimpleDateFormatTest.prototype = new TestCase();
SimpleDateFormatTest.prototype.constructor = SimpleDateFormatTest;
SimpleDateFormatTest.parentclass = TestCase.prototype;
SimpleDateFormatTest.prototype.init = function() {};
SimpleDateFormatTest.prototype.setUp = function() {

	SimpleDateFormatTest.parentclass.setUp.apply(this, []);
	this.date = new Date(2001, 6, 4, 12, 8, 56, 1234);
};
SimpleDateFormatTest.prototype.tearDown = function() {

	SimpleDateFormatTest.parentclass.tearDown.apply(this, []);
	this.date = null;
};
SimpleDateFormatTest.getName = function() {

	return "SimpleDateFormat";
};

// add tests
SimpleDateFormatTest.prototype.testOne = function()
{
	this.assertEquals("2001.07.04 AD at 12:08:57 -0400", new SimpleDateFormat("yyyy.MM.dd G 'at' HH:mm:ss Z").format(this.date));
};

SimpleDateFormatTest.prototype.testTwo = function()
{
	this.assertEquals("Wed, Jul 4, '01", new SimpleDateFormat("EEE, MMM d, ''yy").format(this.date));
};

SimpleDateFormatTest.prototype.testThree = function()
{
	this.assertEquals("12:08 PM", new SimpleDateFormat("h:mm a").format(this.date));
};

SimpleDateFormatTest.prototype.testFour = function()
{
	this.assertEquals("12 o'clock PM, xxx", new SimpleDateFormat("hh 'o''''clock' a, zzzz").format(this.date));
};

SimpleDateFormatTest.prototype.testFive = function()
{
	this.assertEquals("0:08 PM, x", new SimpleDateFormat("K:mm a, z").format(this.date));
};

SimpleDateFormatTest.prototype.testSiz = function()
{
	this.assertEquals("02001.July.04 AD 12:08 PM", new SimpleDateFormat("yyyyy.MMMMM.dd GGG hh:mm aaa").format(this.date));
};

SimpleDateFormatTest.prototype.testSeven = function()
{
	this.assertEquals("Wed, 4 Jul 2001 12:08:57 -0400", new SimpleDateFormat("EEE, d MMM yyyy HH:mm:ss Z").format(this.date));
};

SimpleDateFormatTest.prototype.testEight = function()
{
	this.assertEquals("010704120857-0400", new SimpleDateFormat("yyMMddHHmmssZ").format(this.date));
};

SimpleDateFormatTest.prototype.testNine = function()
{
	this.assertEquals("2001-07-04 12:08:57,234", new SimpleDateFormat("yyyy-MM-dd HH:mm:ss,SSS").format(this.date));
};
